Building Stanford SRP for C-Kermit for Windows/OS2
==================================================

Warning: The Stanford SRP distribution has been unmaintained for over a decade
and may well have unpatched security vulnerabilities. It is not currently
compatible with any version of OpenSSL that is still receiving security updates.

The original [Stanford SRP distribution](http://srp.stanford.edu/download.html) 
is normally built via the Visual C++ 6.0 IDE using its project files. This is 
the best way to build SRP if you're using Visual C++ 6.0 and happen to have the 
IDE available.

If you don't have the IDE, or you're using some other version of Visual C++, a
set of makefiles (originally generated by the IDE and tidied up) are provided
here along with a pair of batch files (mknt.bat and clean.bat) to trigger a
build or clean up after a build. These have only been tested with SRP v2.1.2 and
likely won't work with earlier versions.

These makefiles only build the parts of SRP that C-Kermit actually uses:
srp.dll, krypto.dll, tconf.exe and a few specific header files. They don't 
build the full SRP distribution.

To build SRP:
1. Extract the SRP distribution directly into this directory (so the win32
   directory and other files and directories that make up the full SRP
   distribution are sitting alongside the supplied .mak and .bat files)
2. Make sure you've already built a suitable version of OpenSSL
3. Make sure you've already built libdes (this isn't required by SRP, but is
   required by C-Kermit when SRP support is enabled)
4. Ensure setenv.bat is updated to point at your libdes and openssl builds
5. Open a command window and run setenv.bat as though you were building C-Kermit
6. Change into this directory and run mknt.bat

This procedure has been tested with the following versions of OpenSSL and
Visual C++:
* 0.9.8zf, Visual C++ 6.0
* 1.0.0s, Visual C++ 6.0
* 1.0.1u, Visual C++ 6.0, 7.0 (2002)

OpenSSL 1.1 and newer do not currently work